<?php

namespace app\admin\controller\order;

use app\common\controller\Backend;
use think\Db;
/**
 * 订单管理
 *
 * @icon fa fa-circle-o
 */
class Order extends Backend
{

    /**
     * Order模型对象
     * @var \app\admin\model\order\Order
     */
    protected $model = null;

    public function _initialize()
    {
        parent::_initialize();
        $this->model = new \app\admin\model\order\Order;
        $this->view->assign("orderTypeList", $this->model->getOrderTypeList());
        $this->view->assign("statusList", $this->model->getStatusList());
    }



    /**
     * 默认生成的控制器所继承的父类中有index/add/edit/del/multi五个基础方法、destroy/restore/recyclebin三个回收站方法
     * 因此在当前控制器中可不用编写增删改查的代码,除非需要自己控制这部分逻辑
     * 需要将application/admin/library/traits/Backend.php中对应的方法复制到当前控制器,然后进行修改
     */


    /**
     * 查看
     *
     * @return string|Json
     * @throws \think\Exception
     * @throws DbException
     */
    public function index()
    {
        if(isset($_GET['device_sn'])){
            $device_where = ['device_sign'=>$_GET['device_sn']];
        }else{
            $device_where = [];
        }
        if(get_charge_device_sn()){
            $charge_device_sn = get_charge_device_sn();
            $device_where['device_sign'] = ['in',$charge_device_sn];
        }
        //设置过滤方法
        $this->request->filter(['strip_tags', 'trim']);
        if (false === $this->request->isAjax()) {
            return $this->view->fetch();
        }
        //如果发送的来源是 Selectpage，则转发到 Selectpage
        if ($this->request->request('keyField')) {
            return $this->selectpage();
        }
        [$where, $sort, $order, $offset, $limit] = $this->buildparams();
        $list = $this->model
            ->where($where)
            ->where($device_where)
            ->order($sort, $order)
            ->paginate($limit);
        $total_income = $this->model
            ->where($where)
            ->where($device_where)
            ->sum('need_pay');
        $today_income = $this->model
            ->where($where)
            ->where($device_where)
            ->whereTime('createtime','today')
            ->sum('need_pay');
        $result = ['total' => $list->total(), 'rows' => $list->items(), 'total_income' => $total_income, 'today_income' => $today_income];
        return json($result);
    }

}
